import sys
import gi
gi.require_version("Gtk","3.0")
gi.require_version("WebKit2","4.0")
from gi.repository import Gtk,WebKit2

browser = mfp.require("browser")

def resizeHandler(obj,event):
	if event.width != obj.cWidth or event.height != obj.cHeight:
		obj.cWidth = event.width
		obj.cHeight = event.height
		onResize(obj)

def onResize(obj):
	for webView in obj.cWebViews:
		webView.set_size_request(obj.cWidth,obj.cHeight)

def onClose(obj):
	browser.windows.remove(obj.cParent)
	for webView in obj.cWebViews: webView.destroy()
	obj.destroy()
	if len(browser.windows) == 0:
		Gtk.main_quit()

def addWebView(window,webView,index = -1):
	if index == -1:
		window.cWebViews.append(webView)
	else:
		window.cWebViews[index] = webView
	
	window.cMain.add(webView)
	onResize(window)
	webView.show()
	browser.event.trigger("webview:created",webView)

def create(url = None,webViews = None):
	self = mfp.Bunch()
	obj = Gtk.Window()
	self.obj = obj
	self.data = mfp.Bunch()
	
	obj.cMainWrapper = Gtk.ScrolledWindow()
	obj.add(obj.cMainWrapper)
	obj.cMain = Gtk.Fixed()
	obj.cMainWrapper.add(obj.cMain)
	
	obj.cParent = self
	obj.set_title(browser.name)
	obj.cWidth = 640
	obj.cHeight = 480
	obj.resize(obj.cWidth,obj.cHeight)
	obj.connect("configure-event",resizeHandler)
	obj.connect("destroy",onClose)
	
	obj.cWebViews = []
	if webViews == None: webViews = []
	if len(webViews) < 1:
		webViews.append(browser.createWebView())
		addWebView(obj,webViews[0])
		if url != None:
			webViews[0].load_uri(url)
	else:
		for webView in webViews:
			addWebView(obj,webView)
	
	webView = webViews[0]
	obj.set_focus(webView)
	onResize(obj)
	obj.show_all()
	
	return self