import gi
gi.require_version("Gtk","3.0")
gi.require_version("WebKit2","4.0")
from gi.repository import Gtk,WebKit2,GLib

browser = mfp.require("browser")
eventHandler = mfp.Bunch()

def downloadProgress(download,data_length):
	progress = str(int(download.props.estimated_progress * 100))
	if progress == download.cProgress: return
	download.cProgress = progress
	print(download.props.destination.replace("file://","",1)+ ": " +progress+ "%")

def downloadFailed(download,error):
	download.cError = error.message

def downloadFinished(download):
	print(download.props.destination.replace("file://","",1)+ ": " +download.cError)

def decideDestination(download,suggested_filename):
	fileChooser = Gtk.FileChooserNative()
	fileChooser.set_action(Gtk.FileChooserAction.SAVE)
	fileChooser.set_current_name(suggested_filename)
	response = fileChooser.run()
	if response != Gtk.ResponseType.ACCEPT:
		download.cancel()
		return False
	
	download.props.allow_overwrite = True
	download.set_destination("file://" +fileChooser.get_filename())
	download.cProgress = "-1.00"
	download.connect("received-data",downloadProgress)
	download.cError = "Finished."
	download.connect("failed",downloadFailed)
	download.connect("finished",downloadFinished)
	return False

def download(webContext,download):
	download.connect("decide-destination",decideDestination)
WebKit2.WebContext.get_default().connect("download-started",download)

def decidePolicy(webView,decision,decisionType):
	if decisionType == WebKit2.PolicyDecisionType.RESPONSE:
		if decision.is_mime_type_supported() == False:
			decision.download()
			return True

def onWebviewCreated(webView):
	webView.connect("decide-policy",decidePolicy)
eventHandler["webview:created"] = onWebviewCreated